package Swatparse;

use strict;

sub new {
   my $proto = shift;
   my $class = ref($proto) || $proto;
   my $self = { 
	form => { },
	terms => [ ],
   };
   bless ($self, $class);
   return $self;
}

sub get_form {
   my $self = shift;

   my @pairs;
   if ($ENV{REQUEST_METHOD} eq "POST") {
      my $buffer;
      read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
      @pairs = split(/&/, $buffer);
   }
   elsif ($ENV{REQUEST_METHOD} eq "GET") {
      @pairs = split(/&/, $ENV{'QUERY_STRING'});
   }

   my $pair;
   foreach $pair (@pairs) {
      # Split at the ='s
      my($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      # Turn + to spaces.
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      # Get rid of that hexadecimal coding.
      $self->{form}{$name} = $value;
   }
   return ($self->{form});
}

sub parse_form {
   my $self = shift;
   $self->{sch} = shift;
   $self->{what} = shift;
   $self->{terms} = [ split(' ',$self->{sch}) ];
   return ($self->{terms});
}
1;
